# Binary Ninja

A new kind of reverse engineering platform

---

[Binary Ninja](https://binary.ninja/) is a reverse engineering platform. It focuses on a clean and easy to use interface with a powerful multithreaded analysis built on a custom IL to quickly adapt to a variety of architectures, platforms, and compilers.

- To quickly get started as a new user, check out our [getting started guide](getting-started.md).
- More in-depth user questions are probably answered in our [user manual](./guide/index.md).
- Anyone wanting to get started with our powerful API should check out the [developer section](./dev/index.md). Note that this section is different from our API reference for [Python](https://api.binary.ninja/), [CPP](https://api.binary.ninja/cpp/), and [Rust](https://rust.binary.ninja/binaryninja/).

Of course, if you just have some questions, you might find our [discussions](https://github.com/Vector35/binaryninja-api/discussions) forum helpful, search [search our public issue tracker](https://github.com/Vector35/binaryninja-api/issues) or join the more interactive [slack channel](https://slack.binary.ninja/).
